truffe2/app/urls.py
from django.conf.urls import patterns, include, url
from django.conf import settings

urlpatterns = patterns('',
    url(r'', include('main.urls')),
    url(r'^accounting/core/', include('accounting_core.urls')),
    url(r'^accounting/tools/', include('accounting_tools.urls')),
    url(r'^accounting/main/', include('accounting_main.urls')),
    url(r'^users/', include('users.urls')),
    url(r'^members/', include('members.urls')),
    url(r'^units/', include('units.urls')),
    url(r'^communication/', include('communication.urls')),
    url(r'^notifications/', include('notifications.urls')),
    url(r'^logistics/', include('logistics.urls')),
    url(r'^vehicles/', include('vehicles.urls')),
    url(r'^generic/', include('generic.urls')),

    url(r'^impersonate/', include('impersonate.urls')),

    (r'^' + settings.MEDIA_URL[1:] + '(?P<path>.*)$', 'django.views.static.serve', {'document_root': settings.MEDIA_ROOT}),  # In prod, use apache !
    (r'^' + settings.STATIC_URL[1:] + '(?P<path>.*)$', 'django.views.static.serve', {'document_root': settings.STATIC_ROOT}),  # In prod, use apache !
)

truffe2/communication/urls.py
# -*- coding: utf-8 -*-

from django.conf.urls import patterns, url


urlpatterns = patterns(
    'communication.views',

    url(r'^ecrans$', 'ecrans'),
    url(r'^random_slide$', 'random_slide'),
    url(r'^website_news$', 'website_news'),
    url(r'^logo_public_list$', 'logo_public_list'),
    url(r'^logo_public_load$', 'logo_public_load'),
    url('display/search', 'display_search'),
)

truffe2/communication/models.py
# -*- coding: utf-8 -*-

from django.db import models
from generic.models import GenericModel, GenericStateModel, GenericStateRootModerable, GenericStateUnitValidable, FalseFK, GenericGroupsValidableModel, GenericGroupsModerableModel, GenericGroupsModel, GenericContactableModel, GenericModelWithFiles, GenericExternalUnitAllowed, GenericDelayValidable, GenericDelayValidableInfo, SearchableModel, ModelUsedAsLine, GenericModelWithLines
from django.utils.translation import ugettext_lazy as _
from django.utils.html import escape
from django.utils.safestring import mark_safe
from django.utils.timezone import localtime
from django.core.urlresolvers import reverse

from rights.utils import UnitEditableModel, UnitExternalEditableModel, AutoVisibilityLevel


class _WebsiteNews(GenericModel, GenericGroupsModerableModel, GenericGroupsModel, GenericContactableModel, GenericStateRootModerable, GenericStateModel, UnitEditableModel, SearchableModel):

    class MetaRightsUnit(UnitEditableModel.MetaRightsUnit):
        access = 'COMMUNICATION'
        moderation_access = 'COMMUNICATION'

    title = models.CharField(_(u'Titre'), max_length=255)
    title_en = models.CharField(_(u'Titre anglais'), max_length=255, blank=True, null=True)
    content = models.TextField(_(u'Contenu'))
    content_en = models.TextField(_(u'Contenu anglais'), blank=True, null=True)
    url = models.URLField(max_length=255)
    unit = FalseFK('units.models.Unit')

    start_date = models.DateTimeField(_(u'Date début'), blank=True, null=True)
    end_date = models.DateTimeField(_(u'Date fin'), blank=True, null=True)

    class MetaData:
        list_display = [
            ('title', _('Titre')),
            ('start_date', _(u'Date début')),
            ('end_date', _('Date fin')),
            ('status', _('Statut')),
        ]
        details_display = list_display + [('content', _('Contenu')), ('url', _('URL')), ('title_en', _('Titre anglais')), ('content_en', _('Contenu anglais'))]
        filter_fields = ('title', 'status')

        base_title = _('News AGEPoly')
        list_title = _(u'Liste de toutes les news sur le site de l\'AGEPoly')
        base_icon = 'fa fa-list'
        elem_icon = 'fa fa-bullhorn'

        default_sort = "[3, 'desc']"  # end_date

        menu_id = 'menu-communication-websitenews'

        datetime_fields = ['start_date', 'end_date']

        has_unit = True

        help_list = _(u"""Les news du site de l'AGEPoly sont les nouvelles affichées sur toutes les pages du site de l'AGEPoly.
                        Elles sont soumises à modération par le responsable communication de l'AGEPoly avant d'être visibles.""")

    class MetaEdit:
        datetime_fields = ('start_date', 'end_date')

    class MetaSearch(SearchableModel.MetaSearch):

        extra_text = u""

        fields = [
            'title',
            'title_en',
            'content',
            'content_en',
            'url',
        ]

    class Meta:
        abstract = True

    def __unicode__(self):
        return self.title


class _AgepSlide(GenericModel, GenericGroupsModerableModel, GenericGroupsModel, GenericContactableModel, GenericStateRootModerable, GenericStateModel, UnitEditableModel, SearchableModel):

    class MetaRightsUnit(UnitEditableModel.MetaRightsUnit):
        access = 'COMMUNICATION'
        moderation_access = 'COMMUNICATION'

    title = models.CharField(_(u'Titre'), max_length=255)
    picture = models.ImageField(_(u'Image'), help_text=_(u'Pour des raisons de qualité, il est fortement recommandé d\'envoyer une image en HD (1920x1080)'), upload_to='uploads/slides/')
    unit = FalseFK('units.models.Unit')

    start_date = models.DateTimeField(_(u'Date de début'), blank=True, null=True)
    end_date = models.DateTimeField(_(u'Date de fin'), blank=True, null=True)

    class MetaData:
        list_display = [
            ('title', _('Titre')),
            ('start_date', _(u'Date début')),
            ('end_date', _('Date fin')),
            ('status', _('Statut')),
        ]
        details_display = list_display + [('picture', _('Image')), ('get_image_warning', '')]
        filter_fields = ('title', 'status')

        base_title = _(u'Slide à l\'AGEPoly')
        list_title = _(u'Liste de tous les slides à l\'AGEPoly')
        base_icon = 'fa fa-list'
        elem_icon = 'fa fa-bullhorn'

        default_sort = "[3, 'desc']"  # end_date

        menu_id = 'menu-communication-agepslide'

        datetime_fields = ['start_date', 'end_date']
        images_fields = ['picture', ]
        safe_fields = ['get_image_warning', ]

        has_unit = True

        help_list = _(u"""Les slides à l'AGEPoly sont affichés de manière aléatoire sur les écrans à l'AGEPoly.
            Ils sont soumis à modération par le responsable communication de l'AGEPoly avant d'être visibles.""")

    class MetaEdit:
        datetime_fields = ('start_date', 'end_date')

    class MetaSearch(SearchableModel.MetaSearch):

        extra_text = u"écrans"

        fields = [
            'title',
        ]

    class Meta:
        abstract = True

    def __unicode__(self):
        return self.title

    def get_image_warning(self):
        if self.picture.height < 1080 or self.picture.width < 1920:
            return _(u'<span class="text-warning"><i class="fa fa-warning"></i> Les dimensions de l\'image sont trop petites ! ({}x{} contre 1920x1080 recommandé)'.format(self.picture.width, self.picture.height))


class _Logo(GenericModel, GenericModelWithFiles, AutoVisibilityLevel, UnitEditableModel, SearchableModel):

    class MetaRightsUnit(UnitEditableModel.MetaRightsUnit):
        access = 'COMMUNICATION'

    name = models.CharField(max_length=255)
    unit = FalseFK('units.models.Unit')

    class MetaData:
        list_display = [
            ('name', _('Nom')),
        ]
        details_display = list_display + [('get_visibility_level_display', _(u'Visibilité')), ]
        filter_fields = ('name', )

        base_title = _(u'Logo')
        list_title = _(u'Liste de tous les logos')
        files_title = _(u'Fichiers')
        base_icon = 'fa fa-list'
        elem_icon = 'fa fa-picture-o'

        default_sort = "[1, 'asc']"  # name

        menu_id = 'menu-communication-logo'

        has_unit = True

        help_list = _(u"""Les logos de ton unité.
            Tu peux rendre public les logos, ce qui est recommandé afin d'aider les autres unités lors de constructions graphiques (ex: agenda) ou ton propre comité.
            Un logo peut comporter plusieurs fichiers : ceci te permet d'uploader différents formats pour un même fichier !""")

    class MetaEdit:
        files_title = _(u'Fichiers')
        files_help = _(u'Envoie le ou les fichiers de ton logo. Le système te permet d\'envoyer plusieurs fichiers pour te permettre d\'envoyer des formats différents.')

    class MetaSearch(SearchableModel.MetaSearch):
        extra_text = u""
        index_files = True

        fields = [
            'name',
        ]

    class Meta:
        abstract = True

    def __unicode__(self):
        return self.name

    def get_best_image(self):
        """Try to find a suitable file for thumbnail"""

        for f in self.files.all():
            if f.is_picture():
                return f

        return f

class _Display(GenericModel, GenericGroupsModel, UnitEditableModel, GenericDelayValidableInfo, SearchableModel):

    class MetaRightsUnit(UnitEditableModel.MetaRightsUnit):
        access = 'COMMUNICATION'

    title = models.CharField(_('Titre'), max_length=255)
    description = models.TextField()
    unit = FalseFK('units.models.Unit')

    active = models.BooleanField(_('Actif'), help_text=_(u'Pour désactiver temporairement la posibilité de réserver.'), default=True)

    conditions = models.TextField(_(u'Conditions de réservation'), help_text=_(u'Si tu veux préciser les conditions de réservations pour l\'affichage. Tu peux par exemple mettre un lien vers un contrat.'), blank=True)

    allow_externals = models.BooleanField(_(u'Autoriser les externes'), help_text=_(u'Permet aux externes (pas dans l\'AGEPoly) de réserver l\'affichage.'), default=False)
    conditions_externals = models.TextField(_(u'Conditions de réservation pour les externes'), help_text=_(u'Si tu veux préciser des informations sur la réservation de l\'affichage pour les externes. Remplace le champ \'Conditions\' pour les externe si rempli.'), blank=True)

    allow_calendar = models.BooleanField(_(u'Autoriser tout le monde à voir le calendrier'), help_text=_(u'Permet à tout le monde d\'afficher le calendrier des réservations de l\'affichage'), default=True)
    allow_external_calendar = models.BooleanField(_(u'Autoriser les externes à voir le calendrier'), help_text=_(u'Permet aux externes d\'afficher le calendrier des réservations de l\'affichage. Le calendrier doit être visible.'), default=True)

    class MetaData:
        list_display = [
            ('title', _('Titre')),
            ('active', _('Actif')),
            ('allow_externals', _('Autoriser les externes')),
        ]

        details_display = list_display + [
            ('description', _('Description')),
            ('conditions', _('Conditions')),
            ('conditions_externals', _('Conditions pour les externes')),
            ('max_days', _(u'Nombre maximum de jours de réservation')),
            ('max_days_externals', _(u'Nombre maximum de jours de réservation (externes)')),
            ('minimum_days_before', _(u'Nombre de jours minimum avant réservation')),
            ('minimum_days_before_externals', _(u'Nombre de jours minimum avant réservation (externes)')),
            ('maximum_days_before', _(u'Nombre de jours maximum avant réservation')),
            ('maximum_days_before_externals', _(u'Nombre de jours maximum avant réservation (externes)')),
        ]
        filter_fields = ('title', 'description', 'conditions', 'conditions_externals')

        base_title = _(u'Affichage')

truffe2/communication/views.py
# -*- coding: utf-8 -*-

from django.shortcuts import get_object_or_404, render, redirect
from django.http import Http404, HttpResponse, HttpResponseForbidden, HttpResponseNotFound
from django.contrib.auth.decorators import login_required
from django.utils.timezone import now
from django.db.models import Q
from django.utils.html import strip_tags

import json

from app.utils import update_current_unit
from generic.templatetags.generic_extras import html_check_and_safe

def ecrans(request):
    """View to display the ecran page"""

    return render(request, 'communication/ecrans.html', {})


def random_slide(request):
    """Return the URL to a random slide"""

    from communication.models import AgepSlide

    slide = AgepSlide.objects.filter(status='2_online').exclude(deleted=True).filter(Q(start_date=None) | Q(start_date__lt=now())).filter(Q(end_date=None) | Q(end_date__gt=now())).order_by('?').all()[0]

    return HttpResponse(slide.picture.url)


def website_news(request):
    """Return data to display on website"""

    from communication.models import WebsiteNews

    retour = []

    for news in WebsiteNews.objects.filter(status='2_online').exclude(deleted=True).filter(Q(start_date=None) | Q(start_date__lt=now())).filter(Q(end_date=None) | Q(end_date__gt=now())).order_by('?'):
        if not request.GET.get('only') or request.GET.get('only')[5:] == str(news.pk):
            retour.append({'id': 'T2V1N{}'.format(news.pk), 'title_fr': news.title, 'title_en': news.title_en or news.title, 'content_fr': news.content, 'content_en': news.content_en or news.content, 'url': news.url, 'unit': news.unit.__unicode__(), 'date': str(news.start_date or news.last_log().when)})

    return HttpResponse(json.dumps(retour), content_type='application/json')


@login_required
def logo_public_list(request):
    from units.models import Unit

    units = Unit.objects.order_by('name')

    # La page va charger en ajax les logos pour chaque unité [car il faut
    # tester les droits sur chaque logo et ça peut être lourd]

    return render(request, 'communication/logo_public_list.html', {'units': units})


@login_required
def logo_public_load(request):
    from units.models import Unit

    unit = get_object_or_404(Unit, pk=request.GET.get('pk'))

    logos = []

    for logo in unit.logo_set.filter(deleted=False):
        if logo.files.count() and logo.rights_can('SHOW', request.user):
            logos.append(logo)

    return render(request, 'communication/logo_public_load.html', {'logos': logos, 'unit': unit})

@login_required
def display_search(request):
    
    from communication.models import Display, DisplayReservation
    
    q = request.GET.get('q')
    init = request.GET.get('init')
    unit_pk = request.GET.get('unit_pk', "-1") or "-1"
    
    displays= Display.objects.filter(active=True, deleted=False).order_by('title')
    
    if q:
        displays = displays.filter(title__icontains=q)
    
    if init is not None:
        if not init:
            return HttpResponse(json.dumps([]))
        displays = displays.filter(pk=init)
    
    if unit_pk == "-1":
        displays = displays.filter(allow_externals=True)
    else:
        # Pas de filtre, mais on check que le dude peut faire une réservation
        # dans l'unité
        from units.models import Unit
        get_object_or_404(Unit, pk=unit_pk)
        
        dummy = DisplayReservation()
        update_current_unit(request, unit_pk)
        
        if not dummy.rights_can('CREATE', request.user):
            raise Http404

    retour = map(lambda display: {'id': display.pk, 'text': display.title, 'description': strip_tags(html_check_and_safe(display.description))[:100] + '...', 'unit': str(display.unit)}, displays)
    
    return HttpResponse(json.dumps(retour))

truffe2/communication/templates/communication/displayreservation/edit.html
{% extends "generic/generic/edit.html" %}
{% load i18n %}

{% block edit_bonus %}
    <script type="text/javascript">

        $(function() {
            // Move display up
            var display = $('#id_display').parent().parent().remove();
            $('#id_title').parent().parent().after(display);

            var papa = $('#id_display').parent();
            var val = $('#id_display').val();
            var old_id = $('#id_display').attr('name');
            $('#id_display').remove();

            if (getUrlParameter('autoobjpk') != '' && val == '') {
                val = getUrlParameter('autoobjpk');
            }

            $(papa).append("<input id='id_display' name='" + old_id + "' value='" + val + "' type='text'>");

            $('#id_display').width('92%').select2({
                minimumInputLength: 0,
                ajax: {
                    url: "{% url 'communication.views.display_search' %}",
                    dataType: 'json',
                    data: function (term, page) {
                        return {
                            q: term,
                            unit_pk: $('#input_upk').val()
                        }
                    },
                    results: function (data, page) {
                        return { results: data };
                    },
                },
                initSelection : function (element, callback) {
                    $.ajax("{% url 'communication.views.display_search' %}?init=" + $(element).val() + '&unit_pk=' + $('#input_upk').val(), {'dataType': 'json'}).success(function (data) {
                        callback(data[0]);
                    });
                },
                formatResult: function(result, container, query, escapeMarkup) {
                    return escapeMarkup(result.text) + ' <small class="label label-info">' + escapeMarkup(result.unit) + '</small><br /><small>' + escapeMarkup(result.description) + "</small>";
                },
                formatSelection: function(result, container, escapeMarkup) {
                    return escapeMarkup(result.text) + ' <small class="label label-info">' + escapeMarkup(result.unit) + '</small>';
                },
            }).on('change', function(e) {
                $('#id_display').val(e.val);
            });
        });

    </script>
{% endblock %}

truffe2/communication/templates/communication/displayreservation/show.html
{% extends "generic/generic/show.html" %}
{% load i18n generic_extras %}

{% block bonus_box_after_infos %}
    <div class="col-sm-12 col-md-12 col-lg-6 popover-no-padding">
        {% with w_title="Détails sur l'affiche'" %}{% include "widget/header.html" %}{% endwith %}

        <h3 style="margin-top: 0px;">{% trans "Description" %}</h3>
        {{line.display.description|html_check_and_safe}}

        <h3>{% trans "Conditions de réservation" %}</h3>

        <div class="alert alert-warning" style="margin-top: -15px; margin-bottom: 5px;">{% trans "La personne effectuant la réservation s'engage à respecter les conditions en demandant une validation de la réservation !" %}</div>

        {% if obj.unit %}
            {% if line.display.max_days %}
                <b>{% trans "La réservation ne peut pas durer plus de" %} {{line.display.max_days}} {% trans "jour(s)" %}.</b><br />
            {% endif %}
            {% if line.display.minimum_days_before %}
                <b>{% trans "La réservation doit être faite au moins" %} {{line.display.minimum_days_before}} {% trans "jour(s) à l'avance" %}.</b><br />
            {% endif %}
            {% if line.display.maximum_days_before %}
                <b>{% trans "La réservation doit être faite au plus" %} {{line.display.maximum_days_before}} {% trans "jour(s) à l'avance" %}.</b><br />
            {% endif %}
        {% else %}
            {% if line.display.max_days_externals %}
                <b>{% trans "La réservation ne peut pas durer plus de" %} {{line.display.max_days_externals}} {% trans "jour(s)" %}.</b><br />
            {% endif %}
            {% if line.display.minimum_days_before_externals %}
                <b>{% trans "La réservation doit être faite au moins" %} {{line.display.minimum_days_before_externals}} {% trans "jour(s) à l'avance" %}.</b><br />
            {% endif %}
            {% if line.display.maximum_days_before_externals %}
                <b>{% trans "La réservation doit être faite au plus" %} {{line.display.maximum_days_before_externals}} {% trans "jour(s) à l'avance" %}.</b><br />
            {% endif %}

        {% endif %}

        {% if obj.unit or not line.display.conditions_externals %}
            {{line.display.conditions|html_check_and_safe|default:"<i>Pas de conditions</i>"}}
        {% else %}
            {{line.display.conditions_externals|html_check_and_safe}}
        {% endif %}

        {% include "widget/footer.html" %}
    </div>

    </div><div class="row">
{% endblock %}

{% block row_for_logs %}{% endblock %}